package ims.data;

import java.util.List;

public class Document<T extends ISentence> {

	public List<T> sents;
	public List<String> sIDs;
	public String dID;
	
	public Document(List<T> sents,List<String> sIDs,String dID){
		this.sents=sents;
		this.sIDs=sIDs;
		this.dID=dID;
	}
	
	public static <T extends ISentence> void renormalizeHeadsAndIDsBySentences(List<T> sents){
		int tokOffset=0;
		for(T sent:sents){
			sent.renormalizeTokenOffsetsInHeadAndIDCols(tokOffset);
			tokOffset+=sent.getLength()-1;
		}
	}
	
}
