package ims.io;

import java.io.IOException;

import ims.data.ISentence;
import ims.trans.Options;

public class TakeSenLength {

	public static void main(String[] args) throws IOException{
		int total=0;
		int kept=0;
		Options options=new Options(args);
		Iterable<? extends ISentence> reader=ReaderWriterFactory.getReader(options.train, options.format);
		TabbedWriter writer=ReaderWriterFactory.getWriter(options.out);
		for(ISentence s:reader){
			++total;
			if(s.getLength()<=options.maxLength){
				++kept;
				writer.write(s);
			}
		}
		writer.close();
		System.err.println("Total: "+total);
		System.err.printf ("Kept:  %d  (%.3f%%)\n",kept,100.*kept/total);
	}
}
