package ims.oracle;

import ims.data.Instance;
import ims.oracle.Configuration.TR;
import ims.oracle.DeterministicArcStandardSwapOldOracle.InOrderOrder;
import ims.trans.Options;
import ims.trans.Options.TransitionSystem;

import java.util.List;

public class DynamicArcStandardSwapFullOracle extends AbstractDynamicOracle {

	private InOrderOrder inOrder;
	
	protected DynamicArcStandardSwapFullOracle(TR[] myTRs) {
		super(myTRs);
	}
	
	@Override
	public void initSentence(int[] heads){ //Need this for swap stuff
		inOrder=new InOrderOrder(InOrderOrder.getSequence(heads));
	}

//	@Override
//	List<TR> getActions(IConfiguration c, int[] heads) {
//		boolean canLA=DeterministicArcStandardOracle.canLeftArc(heads, c);
//		boolean canRA=DeterministicArcStandardOracle.canRightArc(heads, c);
//		boolean canSW=DeterministicArcStandardSwapOldOracle.canSwap(heads, c, inOrder);
//		boolean canSH;
//		if(canLA || canRA || canSW)
//			canSH=BruteForceShiftOKCheck.canShift(c, inOrder, heads);
//		else 
//			canSH=true;
//		List<TR> actions=new ArrayList<TR>();
//		if(canLA)
//			actions.add(TR.LA);
//		if(canRA)
//			actions.add(TR.RAS);
//		if(canSW)
//			actions.add(TR.SW);
//		if(canSH)
//			actions.add(TR.SH);
//		return actions;
//	}

//	@Override
//	public boolean isPermissible(IConfiguration c, TR tr, int[] heads) {
//		boolean canLA=DeterministicArcStandardOracle.canLeftArc(heads, c);
//		boolean canRA=DeterministicArcStandardOracle.canRightArc(heads, c);
//		boolean canSW=DeterministicArcStandardSwapOldOracle.canSwap(heads, c, inOrder);
//		boolean canNonShift=canLA || canRA || canSW;
//		switch(tr){
//		case LA:  return canLA;
//		case RAS: return canRA;
//		case SW:  return canSW;
//		case SH:  return canNonShift?BruteForceShiftOKCheck.canShift(c, inOrder, heads):true;
//		default: throw new Error("!");
//		}
//	}

	private final IOracle detOracle=OracleFactory.getStaticOracle(Options.TransitionSystem.ArcSNewSwap);
	@Override
	public List<String> getCanonicalSequence(int[] heads, String[] labels,boolean labeled) {
		return detOracle.getCanonicalSequence(heads, labels, labeled);
	}

	@Override
	public boolean canDoNonProj() {
		return true;
	}

	@Override
	public boolean isCorrectULBLTransition(TR tr, IConfiguration conf, Instance inst) {
		int[] heads=inst.head;
		if(tr==TR.SH){
			if(DeterministicArcStandardOracle.canLeftArc(heads, conf) || DeterministicArcStandardOracle.canRightArc(heads, conf) || DeterministicArcStandardSwapOldOracle.canSwap(heads, conf, inOrder))
				return BruteForceShiftOKCheck.canShift(conf, inOrder, heads);
			else
				return conf.bufferSize()>0;
		}
		switch(tr){
		case LA:  return DeterministicArcStandardOracle.canLeftArc(heads, conf);
		case RAS: return DeterministicArcStandardOracle.canRightArc(heads, conf);
		case SW:  return DeterministicArcStandardSwapOldOracle.canSwap(heads, conf, inOrder);
		default:  throw new Error("not supported");
		}
	}

	@Override
	public TransitionSystem getTS() {
		return TransitionSystem.ArcSFullDynSwap;
	}

}
