package ims.perceptron;

import java.util.Arrays;
import java.util.Random;

public class XTest {

	public static void main(String[] args){

		Random rand=new Random(System.currentTimeMillis());
		
		randTest(rand,true,100);
		
	}

	public static void randTest(Random rand,boolean forcePositive,int iterations){
		boolean[] seenBoth=new boolean[64];
		int[] seenValue=new int[64];
		Arrays.fill(seenValue, -1);
		for(int i=0;i<iterations;++i){
			long l=rand.nextLong();
			if(forcePositive && l<0)
				l=-l;
			
			long r=hash(l,false);
			
			String s=padZeros(Long.toBinaryString(r));
			for(int q=0;q<64;++q){
				if(!seenBoth[q]){
					int b=Integer.parseInt(Character.toString(s.charAt(q)));
					if(seenValue[q]==-1){
						seenValue[q]=b;
					} else if(seenValue[q]!=b){
						seenBoth[q]=true;
					}
				}
			}
		}
		
		for(int i=0;i<64;++i){
			System.out.printf("%-2d: %s\n",i,seenBoth[i]?2:seenValue[i]);
		}
	}
	
	public static long hash(long l,boolean print){
		long r= l;// 27
		if(print){
			System.out.println("l: "+padZeros(Long.toBinaryString(l)));
			System.out.println("r: "+padZeros(Long.toBinaryString(l)));
		}
		l = (l>>13)&0xffffffffffffe000L;
		r ^= l;   // 40
		if(print){
			System.out.println();
			System.out.println("l: "+padZeros(Long.toBinaryString(l)));
			System.out.println("r: "+padZeros(Long.toBinaryString(l)));
		}
		l = (l>>11)&0xffffffffffff0000L;
		r ^= l;   // 51
		if(print){
			System.out.println();
			System.out.println("l: "+padZeros(Long.toBinaryString(l)));
			System.out.println("r: "+padZeros(Long.toBinaryString(l)));
		}
		l = (l>>9)& 0xfffffffffffc0000L; //53
		r ^= l;  // 60
		if(print){
			System.out.println();
			System.out.println("l: "+padZeros(Long.toBinaryString(l)));
			System.out.println("r: "+padZeros(Long.toBinaryString(l)));
		}
		l = (l>>7)& 0xfffffffffff00000L; //62
		r ^=l;    //67
		if(print){
			System.out.println();
			System.out.println("l: "+padZeros(Long.toBinaryString(l)));
			System.out.println("r: "+padZeros(Long.toBinaryString(l)));
		}
		return r;
	}
	
	static String padZeros(String s){
		if(s.length()>63)
			return s;
		StringBuilder sb=new StringBuilder();
		for(int i=0;i<64-s.length();++i)
			sb.append('0');
		sb.append(s);
		return sb.toString();
	}
	
}
