package ims.tag.features;

import ims.hotcoref.symbols.TagSymbolTable;
import ims.tag.ITagContext;
import ims.tag.TagInstance;

public class NLinearContextFeatureSet extends LocalFeatureSet {

	private static final long serialVersionUID = 5090194921332010544L;

	private final int n;
	
	protected NLinearContextFeatureSet(TagSymbolTable symTab,int n) {
		super(symTab);
		this.n=n;
	}

	@Override
	public int extractNonLocalFeatures(int idx, TagInstance inst, ITagContext context) {
		int m=0; int t=31;
		//Just single tags in each direction
		for(int l=1;l<=n;++l){
			sink[m]=t; sink[m]<<=bT; sink[m]|=context.getTag(idx-l); ++m; ++t;
			sink[m]=t; sink[m]<<=bT; sink[m]|=context.getTag(idx+l); ++m; ++t;
		}
		//Then take successively larger n-grams of tags on each side
		for(int l=2;l<=n;++l){
			//left context
			sink[m]=t;
			for(int q=l;q>0;--q){ 
				sink[m]<<=bT; sink[m]|=context.getTag(idx-q);
			}
			++m; ++t;
			//right context
			sink[m]=t;
			for(int q=l;q>0;--q){
				sink[m]<<=bT;sink[m]|=context.getTag(idx+q);
			}
			++m; ++t;
		}
		return m;
	}

}
