package ims.trans;

import ims.data.IModel;
import ims.hotcoref.symbols.SymbolTable;
import ims.perceptron.Long2IntInterface;
import ims.trans.Options.TransitionSystem;
import ims.trans.transitions.ITransitionFilter;

public class Model implements IModel {
	private static final long serialVersionUID = -4460226955156657375L;

	public static final String ZIP_FILE_ENTRY = "_model";

	public final FeatureExtractor fe;
	public final SymbolTable symTab;
	public final float[] parameters;
	public final Long2IntInterface l2i;
	public final ITransitionFilter transitionFilter;
	public final int beamSize;
	public final boolean mergeStates;
	public final boolean labeled;
	public final InstanceMapping instanceMapping;
	public final TransitionSystem ts;
	public final boolean reversed;
	public final int sampleK;
	public final SamplingStoppingCriterion.Criteria stoppingCriterion;
	
	public Model(FeatureExtractor fe, SymbolTable symTab, float[] parameters, Long2IntInterface l2i, ITransitionFilter transitionFilter,int beamSize,boolean mergeStates,boolean labeled,InstanceMapping instanceMapping,TransitionSystem ts,boolean reversed,int sampleK,SamplingStoppingCriterion.Criteria c) {
		this.fe = fe;
		this.symTab = symTab;
		this.parameters = parameters;
		this.l2i = l2i;
		this.transitionFilter = transitionFilter;
		this.beamSize=beamSize;
		this.mergeStates=mergeStates;
		this.labeled=labeled;
		this.instanceMapping=instanceMapping;
		this.ts=ts;
		this.reversed=reversed;
		this.sampleK=sampleK;
		this.stoppingCriterion=c;
	}

	@Override
	public float[] getParameters() {
		return parameters;
	}
	
}
