package ims.trans.features;

import ims.hotcoref.symbols.SymbolTable;
import ims.trans.FeatureExtractor;
import ims.trans.Options;

public class FeatureExtractorFactory {

	public static FeatureExtractor getExtractor(SymbolTable symTab,Options options){
		switch(options.fs){
		case Default:      return new FS_Default(symTab);
		case Standard:     return new FS_Standard(symTab,options);
		case DumbStandard: return new FS_DumbStandard(symTab);
		case DStandard:    return new FS_DStandard(symTab,options);
		case XDStandard:   return new FS_XDStandard(symTab,options);
		default: throw new Error("not implemented");
		}
	}
}
