package ims.trans.labelfilter;

import ims.data.ISentence;
import ims.data.Instance;
import ims.hotcoref.symbols.SymbolTable;

public class NoFilterLabelFilter implements ILabelFilter {
	private static final long serialVersionUID = 7466341144410234228L;

	private final int[] labels;
	
	public NoFilterLabelFilter(SymbolTable symTab){
		int c=0;
		String[] lbls=symTab.deprels.getInverted();
		for(String s:lbls)
			if(s!=null && !s.equals(ISentence.ROOT))
				++c;
		labels=new int[c];
		int d=0;
		for(String s:lbls)
			if(s!=null && !s.equals(ISentence.ROOT))
				labels[d++]=symTab.deprels.lookup(s);		
	}
	
	@Override
	public int[] getAllowedLabels(int head, int dep, Instance is) {
		return labels;
	}

}
