package ims.trans.util;

import ims.data.CoNLL09Sentence;
import ims.trans.Options;
import ims.util.Accuracy;
import ims.util.Pair;
import ims.util.PrecisionRecall;
import ims.util.Util;

public class DocEval {

	public static void main(String[] args){
		Options options=new Options(args);

		Pair<Accuracy,Accuracy> uaslas=Eval.getUASandLAS(options.out, options.gold, CoNLL09Sentence.class);
		PrecisionRecall sb=Eval.evalSentBoundaries(options.out, options.gold);
		Accuracy[] em=Eval.getExactMatchSentBoundaries(options.out, options.gold);

		System.out.println("Syntax");
		System.out.println("UAS: "+uaslas.getLeft().toString());
		System.out.println("LAS: "+uaslas.getRight().toString());
		System.out.println();
		
		System.out.println("Sentence Boundaries:");
		System.out.println(sb.getPRFString());
		
		System.out.println();
		System.out.println("Exact matches (S,S+U,S+U+L)");
		System.out.println(Util.joinStrings("    ",em));

		System.out.println();		
		options.done();
	}
}
