package ims.trans.util;

import ims.data.ISentence;
import ims.io.Format;
import ims.io.StreamIteratorReader;
import ims.oracle.DeterministicArcStandardSwapOldOracle.InOrderOrder;

import java.util.Iterator;
import java.util.List;

public class PrintProjectiveOrder {

	public static void main(String[] args) throws Exception{
		Iterator<ISentence> it=new StreamIteratorReader(System.in,Format.CoNLL06);
		while(it.hasNext()){
			ISentence s=it.next();
			System.out.println(getProjectiveOrderFormatted(s));
//			List<Integer> l=InOrderOrder.getSequence(s.head);
//			for(Integer i:l){
//				System.out.printf("%-3d  %s\n",i,s.form[i]);
//			}
		}
	}
	
	public static String getProjectiveOrderFormatted(ISentence s){
		StringBuilder sb=new StringBuilder();
		List<Integer> l=InOrderOrder.getSequence(s.getGoldHeads());
		String[] form=s.getForms();
		for(Integer i:l)
			sb.append(String.format("%-3d  %s\n",i,form[i]));
		return sb.toString();
	}
}
