package ims.util;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class DisjointSetZeroToN {

	protected int[] parents;
	protected int subsetCount;
	
	public DisjointSetZeroToN(int length){
		this.subsetCount=length;
		this.parents=new int[length];
		for(int i=0;i<parents.length;++i)
			parents[i]=i;
	}
	
	public int find(int i){
		int parent=parents[i];
		if(parent==i)
			return parent;
		else
			return find(parent);
	}
	
	public void union(int x,int y){
		int xRoot=find(x);
		int yRoot=find(y);
		if(xRoot==yRoot)
			return;
		parents[xRoot]=yRoot;
		subsetCount--;
	}
	
	public int getSubsets() {
		return subsetCount;
	}
	
	public String toString(){
		if(subsetCount==1)
			return "[0.."+(parents.length-1)+"]";
		Map<Integer,List<Integer>> m=new HashMap<Integer,List<Integer>>();
		for(int i=0;i<parents.length;++i){
			int r=this.find(i);
			List<Integer> l=m.get(r);
			if(l==null){
				l=new ArrayList<Integer>();
				m.put(r, l);
			}
			l.add(i);
		}
		List<Integer> keys=new ArrayList<Integer>(m.keySet());
		Collections.sort(keys);
		StringBuilder sb=new StringBuilder();
		for(Integer r:keys){
			sb.append("[");
			for(Integer i:m.get(r))
				sb.append(i).append(',');
			sb.append("]\n");
		}
		return sb.toString();
	}

}
