package ims.util;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Random;

public class ShuffleSentences {

	public static void main(String[] args) throws Exception {
		long seed=53401529811412711l;
		if(args.length>0)
			seed=Long.parseLong(args[0]);
		
		Random rnd=new Random(seed);
		
		//read
		BufferedReader reader=new BufferedReader(new InputStreamReader(System.in,"utf8"));
		List<List<String>> sentences=new ArrayList<List<String>>();
		List<String> sent=new ArrayList<String>();
		String line;
		while((line=reader.readLine())!=null){
			if(line.matches("^\\s*$")){ //end of sentence
				sentences.add(sent);
				sent=new ArrayList<String>();
			} else {
				sent.add(line);
			}
		}
		reader.close();
		
		//shuffle
		Collections.shuffle(sentences,rnd);
		
		//write
		BufferedWriter writer=new BufferedWriter(new OutputStreamWriter(System.out,"utf8"));
		for(List<String> s:sentences){
			for(String l:s){
				writer.write(l);
				writer.newLine();
			}
			writer.newLine();
		}
		writer.close();
	}
}
